//+------------------------------------------------------------------------------+
//|                                            MTF_PriceChannel_FiboLevels.mq4   |
//|  PriceChannel_osc   sw                                                       | 
//+------------------------------------------------------------------------------+
//2008fxtsd        ik 

#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 RoyalBlue
#property indicator_color2 Blue
#property indicator_color3 RoyalBlue
//#property indicator_color8 RoyalBlue
#property  indicator_style1  0
#property  indicator_style2  2
#property  indicator_style3  0

extern int TimeFrame=0;
extern int Range=14;

double UpBuffer[];
double MdBuffer[];
double DnBuffer[];

double UpBuffer1[];
double DnBuffer1[];
double MdBuffer1[];


int i;  //
string PeriodName;  //  

int init()
{
string short_name;

IndicatorBuffers(6);

SetIndexStyle(0,DRAW_LINE);
SetIndexStyle(1,DRAW_LINE);
SetIndexStyle(2,DRAW_LINE);

//
SetIndexBuffer(0,UpBuffer);
SetIndexBuffer(1,MdBuffer);
SetIndexBuffer(2,DnBuffer);

SetIndexBuffer(3,UpBuffer1);
SetIndexBuffer(4,MdBuffer1);
SetIndexBuffer(5,DnBuffer1);



////






switch(TimeFrame) //   TimeFrame      
  {
  case 1    : TimeFrame=PERIOD_M1;  break; //   ,     
  case 5    : TimeFrame=PERIOD_M5;  break;
  case 15   : TimeFrame=PERIOD_M15; break;
  case 30   : TimeFrame=PERIOD_M30; break;
  case 60   : TimeFrame=PERIOD_H1;  break;
  case 240  : TimeFrame=PERIOD_H4;  break;
  case 1440 : TimeFrame=PERIOD_D1;  break;
  case 10080: TimeFrame=PERIOD_W1;  break;
  case 43200: TimeFrame=PERIOD_MN1; break;
  default   : TimeFrame=Period();   break;
  }

switch(TimeFrame) //   
  {
  case PERIOD_M1    : PeriodName="M1";  break;
  case PERIOD_M5    : PeriodName="M5";  break;
  case PERIOD_M15   : PeriodName="M15"; break;
  case PERIOD_M30   : PeriodName="M30"; break;
  case PERIOD_H1    : PeriodName="H1";  break;
  case PERIOD_H4    : PeriodName="H4";  break;
  case PERIOD_D1    : PeriodName="D1";  break;
  case PERIOD_W1    : PeriodName="W1";  break;
  case PERIOD_MN1   : PeriodName="MN"; break;
  }

short_name="PriceChannel_osc ("+Range+") ["+TimeFrame+"] ";
IndicatorShortName(short_name);

SetIndexLabel(0,"PC UpperChan "+short_name);
SetIndexLabel(1,"PC MidLine "+short_name);
SetIndexLabel(2,"PC Lower Chan "+short_name);


return(0);
}

int start()
{
int i,counted_bars=IndicatorCounted();
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<Bars;i++)
      {
DnBuffer[i]=0.0;         
UpBuffer[i]=0.0;         
MdBuffer[i]=0.0;               

      }
//----
datetime TimeArray[];
double LowArray[],HighArray[];
int y=0;  //   

if (TimeFrame<Period()) //      
  {
  SetIndexDrawBegin(0,Bars);  //  
  SetIndexDrawBegin(1,Bars);
  SetIndexDrawBegin(2,Bars);


  return(0);
  }
//       
ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame);
//  Low  
ArrayCopySeries(LowArray,MODE_LOW,Symbol(),TimeFrame);
// High
ArrayCopySeries(HighArray,MODE_HIGH,Symbol(),TimeFrame);

for(i=0,y=0;i<Bars-counted_bars;i++)
  {
  //           , 
  //        (   )
  if (Time[i]<TimeArray[y]) y++;
  //|   /    ,
  DnBuffer1[i]=LowArray[Lowest(NULL,TimeFrame,MODE_LOW,Range,y)];
  //|        
  UpBuffer1[i]=HighArray[Highest(NULL,TimeFrame,MODE_HIGH,Range,y)];
  //|LowArray  HighArray
  MdBuffer1[i]=(UpBuffer1[i]+DnBuffer1[i])/2;
  
  DnBuffer[i]=DnBuffer1[i]-MdBuffer1[i];
  UpBuffer[i]=UpBuffer1[i]-MdBuffer1[i];


  
  }

return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   Comment("");
//----
   return(0);
  }

